#include <stdio.h>
#include <stdlib.h>

int max=-9999999;

void predjisve(int a[], int poznanici[][3], int prijatelji[], int neprijatelji[], int pozicija, int n, int m)
{
    if(pozicija==m)
    {
        int temp=izracunaj(a,prijatelji,neprijatelji,n);
        if(temp>max)
        {
            max=temp;
        }
    }
    else
    {
        for(int i=pozicija;i<m;i++)
        {
            if(poznanici[i][2]==1)
            {
                predjisve(a,poznanici,prijatelji,neprijatelji,pozicija+1,n,m);
                poznanici[i][2]==0;
                prijatelji[poznanici[i][0]-1]--;
                neprijatelji[poznanici[i][0]-1]++;
                prijatelji[poznanici[i][1]-1]--;
                neprijatelji[poznanici[i][1]-1]++;
                predjisve(a,poznanici,prijatelji,neprijatelji,pozicija+1,n,m);
            }
            else
            {
                predjisve(a,poznanici,prijatelji,neprijatelji,pozicija+1,n,m);
                poznanici[i][2]==1;
                prijatelji[poznanici[i][0]-1]++;
                neprijatelji[poznanici[i][0]-1]--;
                prijatelji[poznanici[i][1]-1]++;
                neprijatelji[poznanici[i][1]-1]--;
                predjisve(a,poznanici,prijatelji,neprijatelji,pozicija+1,n,m);
            }

        }
    }
}

int izracunaj(int a[], int prijatelji[], int neprijatelji[], int n)
{
    int suma=0;
    for(int i=0;i<n;i++)
    {
        suma+=a[i]*(prijatelji[i]-neprijatelji[i]);
    }
    return suma;
}

int main()
{
    int n,m;
    scanf("%d%d",&n,&m);
    int a[n];
    int prijatelji[n],neprijatelji[n];
    for(int i=0;i<n;i++)
    {
        scanf("%d",&a[i]);
        prijatelji[i]=0;
        neprijatelji[i]=0;
    }
    int poznanici[m][3];
    for(int i=0;i<m;i++)
    {
        scanf("%d%d",&poznanici[i][0],&poznanici[i][1]);
        poznanici[i][2]=1;
        prijatelji[poznanici[i][0]-1]++;
        prijatelji[poznanici[i][1]-1]++;
    }
    predjisve(a,poznanici,prijatelji,neprijatelji,0,n,m);
    printf("%d",max);
}